r"""
    This code was generated by
   ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
    |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
    |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \

    Twilio - Messaging
    This is the public Twilio REST API.

    NOTE: This class is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
    Do not edit the class manually.
"""


from typing import Optional
from twilio.base import deserialize, values
from twilio.base.instance_context import InstanceContext
from twilio.base.instance_resource import InstanceResource
from twilio.base.list_resource import ListResource
from twilio.base.version import Version
from twilio.base.page import Page


class AlphaSenderInstance(InstanceResource):
    def __init__(self, version, payload, service_sid: str, sid: Optional[str] = None):
        """
        Initialize the AlphaSenderInstance

        :returns: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """
        super().__init__(version)

        self._properties = {
            "sid": payload.get("sid"),
            "account_sid": payload.get("account_sid"),
            "service_sid": payload.get("service_sid"),
            "date_created": deserialize.iso8601_datetime(payload.get("date_created")),
            "date_updated": deserialize.iso8601_datetime(payload.get("date_updated")),
            "alpha_sender": payload.get("alpha_sender"),
            "capabilities": payload.get("capabilities"),
            "url": payload.get("url"),
        }

        self._solution = {
            "service_sid": service_sid,
            "sid": sid or self._properties["sid"],
        }
        self._context: Optional[AlphaSenderContext] = None

    @property
    def _proxy(self):
        """
        Generate an instance context for the instance, the context is capable of
        performing various actions. All instance actions are proxied to the context

        :returns: AlphaSenderContext for this AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderContext
        """
        if self._context is None:
            self._context = AlphaSenderContext(
                self._version,
                service_sid=self._solution["service_sid"],
                sid=self._solution["sid"],
            )
        return self._context

    @property
    def sid(self):
        """
        :returns: The unique string that we created to identify the AlphaSender resource.
        :rtype: str
        """
        return self._properties["sid"]

    @property
    def account_sid(self):
        """
        :returns: The SID of the [Account](https://www.twilio.com/docs/iam/api/account) that created the AlphaSender resource.
        :rtype: str
        """
        return self._properties["account_sid"]

    @property
    def service_sid(self):
        """
        :returns: The SID of the [Service](https://www.twilio.com/docs/chat/rest/service-resource) the resource is associated with.
        :rtype: str
        """
        return self._properties["service_sid"]

    @property
    def date_created(self):
        """
        :returns: The date and time in GMT when the resource was created specified in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format.
        :rtype: datetime
        """
        return self._properties["date_created"]

    @property
    def date_updated(self):
        """
        :returns: The date and time in GMT when the resource was last updated specified in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format.
        :rtype: datetime
        """
        return self._properties["date_updated"]

    @property
    def alpha_sender(self):
        """
        :returns: The Alphanumeric Sender ID string.
        :rtype: str
        """
        return self._properties["alpha_sender"]

    @property
    def capabilities(self):
        """
        :returns: An array of values that describe whether the number can receive calls or messages. Can be: `SMS`.
        :rtype: list[str]
        """
        return self._properties["capabilities"]

    @property
    def url(self):
        """
        :returns: The absolute URL of the AlphaSender resource.
        :rtype: str
        """
        return self._properties["url"]

    def delete(self):
        """
        Deletes the AlphaSenderInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return self._proxy.delete()

    async def delete_async(self):
        """
        Asynchronous coroutine that deletes the AlphaSenderInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return await self._proxy.delete_async()

    def fetch(self):
        """
        Fetch the AlphaSenderInstance


        :returns: The fetched AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """
        return self._proxy.fetch()

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the AlphaSenderInstance


        :returns: The fetched AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """
        return await self._proxy.fetch_async()

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        context = " ".join("{}={}".format(k, v) for k, v in self._solution.items())
        return "<Twilio.Messaging.V1.AlphaSenderInstance {}>".format(context)


class AlphaSenderContext(InstanceContext):
    def __init__(self, version: Version, service_sid: str, sid: str):
        """
        Initialize the AlphaSenderContext

        :param Version version: Version that contains the resource
        :param service_sid: The SID of the [Service](https://www.twilio.com/docs/chat/rest/service-resource) to fetch the resource from.
        :param sid: The SID of the AlphaSender resource to fetch.

        :returns: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderContext
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderContext
        """
        super().__init__(version)

        # Path Solution
        self._solution = {
            "service_sid": service_sid,
            "sid": sid,
        }
        self._uri = "/Services/{service_sid}/AlphaSenders/{sid}".format(
            **self._solution
        )

    def delete(self):
        """
        Deletes the AlphaSenderInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return self._version.delete(
            method="DELETE",
            uri=self._uri,
        )

    async def delete_async(self):
        """
        Asynchronous coroutine that deletes the AlphaSenderInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return await self._version.delete_async(
            method="DELETE",
            uri=self._uri,
        )

    def fetch(self):
        """
        Fetch the AlphaSenderInstance


        :returns: The fetched AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """

        payload = self._version.fetch(
            method="GET",
            uri=self._uri,
        )

        return AlphaSenderInstance(
            self._version,
            payload,
            service_sid=self._solution["service_sid"],
            sid=self._solution["sid"],
        )

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the AlphaSenderInstance


        :returns: The fetched AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """

        payload = await self._version.fetch_async(
            method="GET",
            uri=self._uri,
        )

        return AlphaSenderInstance(
            self._version,
            payload,
            service_sid=self._solution["service_sid"],
            sid=self._solution["sid"],
        )

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        context = " ".join("{}={}".format(k, v) for k, v in self._solution.items())
        return "<Twilio.Messaging.V1.AlphaSenderContext {}>".format(context)


class AlphaSenderPage(Page):
    def get_instance(self, payload):
        """
        Build an instance of AlphaSenderInstance

        :param dict payload: Payload response from the API

        :returns: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """
        return AlphaSenderInstance(
            self._version, payload, service_sid=self._solution["service_sid"]
        )

    def __repr__(self) -> str:
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        """
        return "<Twilio.Messaging.V1.AlphaSenderPage>"


class AlphaSenderList(ListResource):
    def __init__(self, version: Version, service_sid: str):
        """
        Initialize the AlphaSenderList

        :param Version version: Version that contains the resource
        :param service_sid: The SID of the [Service](https://www.twilio.com/docs/chat/rest/service-resource) to read the resources from.

        :returns: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderList
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderList
        """
        super().__init__(version)

        # Path Solution
        self._solution = {
            "service_sid": service_sid,
        }
        self._uri = "/Services/{service_sid}/AlphaSenders".format(**self._solution)

    def create(self, alpha_sender):
        """
        Create the AlphaSenderInstance

        :param str alpha_sender: The Alphanumeric Sender ID string. Can be up to 11 characters long. Valid characters are A-Z, a-z, 0-9, space, hyphen `-`, plus `+`, underscore `_` and ampersand `&`. This value cannot contain only numbers.

        :returns: The created AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """
        data = values.of(
            {
                "AlphaSender": alpha_sender,
            }
        )

        payload = self._version.create(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return AlphaSenderInstance(
            self._version, payload, service_sid=self._solution["service_sid"]
        )

    async def create_async(self, alpha_sender):
        """
        Asynchronously create the AlphaSenderInstance

        :param str alpha_sender: The Alphanumeric Sender ID string. Can be up to 11 characters long. Valid characters are A-Z, a-z, 0-9, space, hyphen `-`, plus `+`, underscore `_` and ampersand `&`. This value cannot contain only numbers.

        :returns: The created AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance
        """
        data = values.of(
            {
                "AlphaSender": alpha_sender,
            }
        )

        payload = await self._version.create_async(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return AlphaSenderInstance(
            self._version, payload, service_sid=self._solution["service_sid"]
        )

    def stream(self, limit=None, page_size=None):
        """
        Streams AlphaSenderInstance records from the API as a generator stream.
        This operation lazily loads records as efficiently as possible until the limit
        is reached.
        The results are returned as a generator, so this operation is memory efficient.

        :param int limit: Upper limit for the number of records to return. stream()
                          guarantees to never return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, stream() will attempt to read the
                              limit with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance]
        """
        limits = self._version.read_limits(limit, page_size)
        page = self.page(page_size=limits["page_size"])

        return self._version.stream(page, limits["limit"])

    async def stream_async(self, limit=None, page_size=None):
        """
        Asynchronously streams AlphaSenderInstance records from the API as a generator stream.
        This operation lazily loads records as efficiently as possible until the limit
        is reached.
        The results are returned as a generator, so this operation is memory efficient.

        :param int limit: Upper limit for the number of records to return. stream()
                          guarantees to never return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, stream() will attempt to read the
                              limit with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance]
        """
        limits = self._version.read_limits(limit, page_size)
        page = await self.page_async(page_size=limits["page_size"])

        return await self._version.stream_async(page, limits["limit"])

    def list(self, limit=None, page_size=None):
        """
        Lists AlphaSenderInstance records from the API as a list.
        Unlike stream(), this operation is eager and will load `limit` records into
        memory before returning.

        :param int limit: Upper limit for the number of records to return. list() guarantees
                          never to return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, list() will attempt to read the limit
                              with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance]
        """
        return list(
            self.stream(
                limit=limit,
                page_size=page_size,
            )
        )

    async def list_async(self, limit=None, page_size=None):
        """
        Asynchronously lists AlphaSenderInstance records from the API as a list.
        Unlike stream(), this operation is eager and will load `limit` records into
        memory before returning.

        :param int limit: Upper limit for the number of records to return. list() guarantees
                          never to return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, list() will attempt to read the limit
                              with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderInstance]
        """
        return list(
            await self.stream_async(
                limit=limit,
                page_size=page_size,
            )
        )

    def page(
        self, page_token=values.unset, page_number=values.unset, page_size=values.unset
    ):
        """
        Retrieve a single page of AlphaSenderInstance records from the API.
        Request is executed immediately

        :param str page_token: PageToken provided by the API
        :param int page_number: Page Number, this value is simply for client state
        :param int page_size: Number of records to return, defaults to 50

        :returns: Page of AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderPage
        """
        data = values.of(
            {
                "PageToken": page_token,
                "Page": page_number,
                "PageSize": page_size,
            }
        )

        response = self._version.page(method="GET", uri=self._uri, params=data)
        return AlphaSenderPage(self._version, response, self._solution)

    async def page_async(
        self, page_token=values.unset, page_number=values.unset, page_size=values.unset
    ):
        """
        Asynchronously retrieve a single page of AlphaSenderInstance records from the API.
        Request is executed immediately

        :param str page_token: PageToken provided by the API
        :param int page_number: Page Number, this value is simply for client state
        :param int page_size: Number of records to return, defaults to 50

        :returns: Page of AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderPage
        """
        data = values.of(
            {
                "PageToken": page_token,
                "Page": page_number,
                "PageSize": page_size,
            }
        )

        response = await self._version.page_async(
            method="GET", uri=self._uri, params=data
        )
        return AlphaSenderPage(self._version, response, self._solution)

    def get_page(self, target_url):
        """
        Retrieve a specific page of AlphaSenderInstance records from the API.
        Request is executed immediately

        :param str target_url: API-generated URL for the requested results page

        :returns: Page of AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderPage
        """
        response = self._version.domain.twilio.request("GET", target_url)
        return AlphaSenderPage(self._version, response, self._solution)

    async def get_page_async(self, target_url):
        """
        Asynchronously retrieve a specific page of AlphaSenderInstance records from the API.
        Request is executed immediately

        :param str target_url: API-generated URL for the requested results page

        :returns: Page of AlphaSenderInstance
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderPage
        """
        response = await self._version.domain.twilio.request_async("GET", target_url)
        return AlphaSenderPage(self._version, response, self._solution)

    def get(self, sid):
        """
        Constructs a AlphaSenderContext

        :param sid: The SID of the AlphaSender resource to fetch.

        :returns: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderContext
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderContext
        """
        return AlphaSenderContext(
            self._version, service_sid=self._solution["service_sid"], sid=sid
        )

    def __call__(self, sid):
        """
        Constructs a AlphaSenderContext

        :param sid: The SID of the AlphaSender resource to fetch.

        :returns: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderContext
        :rtype: twilio.rest.messaging.v1.service.alpha_sender.AlphaSenderContext
        """
        return AlphaSenderContext(
            self._version, service_sid=self._solution["service_sid"], sid=sid
        )

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        return "<Twilio.Messaging.V1.AlphaSenderList>"
