r"""
    This code was generated by
   ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
    |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
    |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \

    Twilio - Serverless
    This is the public Twilio REST API.

    NOTE: This class is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
    Do not edit the class manually.
"""


from typing import Optional
from twilio.base import deserialize, values
from twilio.base.instance_context import InstanceContext
from twilio.base.instance_resource import InstanceResource
from twilio.base.list_resource import ListResource
from twilio.base.version import Version
from twilio.base.page import Page
from twilio.rest.serverless.v1.service.asset import AssetList
from twilio.rest.serverless.v1.service.build import BuildList
from twilio.rest.serverless.v1.service.environment import EnvironmentList
from twilio.rest.serverless.v1.service.function import FunctionList


class ServiceInstance(InstanceResource):
    def __init__(self, version, payload, sid: Optional[str] = None):
        """
        Initialize the ServiceInstance

        :returns: twilio.rest.serverless.v1.service.ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        super().__init__(version)

        self._properties = {
            "sid": payload.get("sid"),
            "account_sid": payload.get("account_sid"),
            "friendly_name": payload.get("friendly_name"),
            "unique_name": payload.get("unique_name"),
            "include_credentials": payload.get("include_credentials"),
            "ui_editable": payload.get("ui_editable"),
            "domain_base": payload.get("domain_base"),
            "date_created": deserialize.iso8601_datetime(payload.get("date_created")),
            "date_updated": deserialize.iso8601_datetime(payload.get("date_updated")),
            "url": payload.get("url"),
            "links": payload.get("links"),
        }

        self._solution = {
            "sid": sid or self._properties["sid"],
        }
        self._context: Optional[ServiceContext] = None

    @property
    def _proxy(self):
        """
        Generate an instance context for the instance, the context is capable of
        performing various actions. All instance actions are proxied to the context

        :returns: ServiceContext for this ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceContext
        """
        if self._context is None:
            self._context = ServiceContext(
                self._version,
                sid=self._solution["sid"],
            )
        return self._context

    @property
    def sid(self):
        """
        :returns: The unique string that we created to identify the Service resource.
        :rtype: str
        """
        return self._properties["sid"]

    @property
    def account_sid(self):
        """
        :returns: The SID of the [Account](https://www.twilio.com/docs/iam/api/account) that created the Service resource.
        :rtype: str
        """
        return self._properties["account_sid"]

    @property
    def friendly_name(self):
        """
        :returns: The string that you assigned to describe the Service resource.
        :rtype: str
        """
        return self._properties["friendly_name"]

    @property
    def unique_name(self):
        """
        :returns: A user-defined string that uniquely identifies the Service resource. It can be used in place of the Service resource's `sid` in the URL to address the Service resource.
        :rtype: str
        """
        return self._properties["unique_name"]

    @property
    def include_credentials(self):
        """
        :returns: Whether to inject Account credentials into a function invocation context.
        :rtype: bool
        """
        return self._properties["include_credentials"]

    @property
    def ui_editable(self):
        """
        :returns: Whether the Service resource's properties and subresources can be edited via the UI.
        :rtype: bool
        """
        return self._properties["ui_editable"]

    @property
    def domain_base(self):
        """
        :returns: The base domain name for this Service, which is a combination of the unique name and a randomly generated string.
        :rtype: str
        """
        return self._properties["domain_base"]

    @property
    def date_created(self):
        """
        :returns: The date and time in GMT when the Service resource was created specified in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format.
        :rtype: datetime
        """
        return self._properties["date_created"]

    @property
    def date_updated(self):
        """
        :returns: The date and time in GMT when the Service resource was last updated specified in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format.
        :rtype: datetime
        """
        return self._properties["date_updated"]

    @property
    def url(self):
        """
        :returns: The absolute URL of the Service resource.
        :rtype: str
        """
        return self._properties["url"]

    @property
    def links(self):
        """
        :returns: The URLs of the Service's nested resources.
        :rtype: dict
        """
        return self._properties["links"]

    def delete(self):
        """
        Deletes the ServiceInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return self._proxy.delete()

    async def delete_async(self):
        """
        Asynchronous coroutine that deletes the ServiceInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return await self._proxy.delete_async()

    def fetch(self):
        """
        Fetch the ServiceInstance


        :returns: The fetched ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        return self._proxy.fetch()

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the ServiceInstance


        :returns: The fetched ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        return await self._proxy.fetch_async()

    def update(
        self,
        include_credentials=values.unset,
        friendly_name=values.unset,
        ui_editable=values.unset,
    ):
        """
        Update the ServiceInstance

        :param bool include_credentials: Whether to inject Account credentials into a function invocation context.
        :param str friendly_name: A descriptive string that you create to describe the Service resource. It can be a maximum of 255 characters.
        :param bool ui_editable: Whether the Service resource's properties and subresources can be edited via the UI. The default value is `false`.

        :returns: The updated ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        return self._proxy.update(
            include_credentials=include_credentials,
            friendly_name=friendly_name,
            ui_editable=ui_editable,
        )

    async def update_async(
        self,
        include_credentials=values.unset,
        friendly_name=values.unset,
        ui_editable=values.unset,
    ):
        """
        Asynchronous coroutine to update the ServiceInstance

        :param bool include_credentials: Whether to inject Account credentials into a function invocation context.
        :param str friendly_name: A descriptive string that you create to describe the Service resource. It can be a maximum of 255 characters.
        :param bool ui_editable: Whether the Service resource's properties and subresources can be edited via the UI. The default value is `false`.

        :returns: The updated ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        return await self._proxy.update_async(
            include_credentials=include_credentials,
            friendly_name=friendly_name,
            ui_editable=ui_editable,
        )

    @property
    def assets(self):
        """
        Access the assets

        :returns: twilio.rest.serverless.v1.service.AssetList
        :rtype: twilio.rest.serverless.v1.service.AssetList
        """
        return self._proxy.assets

    @property
    def builds(self):
        """
        Access the builds

        :returns: twilio.rest.serverless.v1.service.BuildList
        :rtype: twilio.rest.serverless.v1.service.BuildList
        """
        return self._proxy.builds

    @property
    def environments(self):
        """
        Access the environments

        :returns: twilio.rest.serverless.v1.service.EnvironmentList
        :rtype: twilio.rest.serverless.v1.service.EnvironmentList
        """
        return self._proxy.environments

    @property
    def functions(self):
        """
        Access the functions

        :returns: twilio.rest.serverless.v1.service.FunctionList
        :rtype: twilio.rest.serverless.v1.service.FunctionList
        """
        return self._proxy.functions

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        context = " ".join("{}={}".format(k, v) for k, v in self._solution.items())
        return "<Twilio.Serverless.V1.ServiceInstance {}>".format(context)


class ServiceContext(InstanceContext):
    def __init__(self, version: Version, sid: str):
        """
        Initialize the ServiceContext

        :param Version version: Version that contains the resource
        :param sid: The `sid` or `unique_name` of the Service resource to update.

        :returns: twilio.rest.serverless.v1.service.ServiceContext
        :rtype: twilio.rest.serverless.v1.service.ServiceContext
        """
        super().__init__(version)

        # Path Solution
        self._solution = {
            "sid": sid,
        }
        self._uri = "/Services/{sid}".format(**self._solution)

        self._assets: Optional[AssetList] = None
        self._builds: Optional[BuildList] = None
        self._environments: Optional[EnvironmentList] = None
        self._functions: Optional[FunctionList] = None

    def delete(self):
        """
        Deletes the ServiceInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return self._version.delete(
            method="DELETE",
            uri=self._uri,
        )

    async def delete_async(self):
        """
        Asynchronous coroutine that deletes the ServiceInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return await self._version.delete_async(
            method="DELETE",
            uri=self._uri,
        )

    def fetch(self):
        """
        Fetch the ServiceInstance


        :returns: The fetched ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """

        payload = self._version.fetch(
            method="GET",
            uri=self._uri,
        )

        return ServiceInstance(
            self._version,
            payload,
            sid=self._solution["sid"],
        )

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the ServiceInstance


        :returns: The fetched ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """

        payload = await self._version.fetch_async(
            method="GET",
            uri=self._uri,
        )

        return ServiceInstance(
            self._version,
            payload,
            sid=self._solution["sid"],
        )

    def update(
        self,
        include_credentials=values.unset,
        friendly_name=values.unset,
        ui_editable=values.unset,
    ):
        """
        Update the ServiceInstance

        :param bool include_credentials: Whether to inject Account credentials into a function invocation context.
        :param str friendly_name: A descriptive string that you create to describe the Service resource. It can be a maximum of 255 characters.
        :param bool ui_editable: Whether the Service resource's properties and subresources can be edited via the UI. The default value is `false`.

        :returns: The updated ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        data = values.of(
            {
                "IncludeCredentials": include_credentials,
                "FriendlyName": friendly_name,
                "UiEditable": ui_editable,
            }
        )

        payload = self._version.update(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return ServiceInstance(self._version, payload, sid=self._solution["sid"])

    async def update_async(
        self,
        include_credentials=values.unset,
        friendly_name=values.unset,
        ui_editable=values.unset,
    ):
        """
        Asynchronous coroutine to update the ServiceInstance

        :param bool include_credentials: Whether to inject Account credentials into a function invocation context.
        :param str friendly_name: A descriptive string that you create to describe the Service resource. It can be a maximum of 255 characters.
        :param bool ui_editable: Whether the Service resource's properties and subresources can be edited via the UI. The default value is `false`.

        :returns: The updated ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        data = values.of(
            {
                "IncludeCredentials": include_credentials,
                "FriendlyName": friendly_name,
                "UiEditable": ui_editable,
            }
        )

        payload = await self._version.update_async(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return ServiceInstance(self._version, payload, sid=self._solution["sid"])

    @property
    def assets(self):
        """
        Access the assets

        :returns: twilio.rest.serverless.v1.service.AssetList
        :rtype: twilio.rest.serverless.v1.service.AssetList
        """
        if self._assets is None:
            self._assets = AssetList(
                self._version,
                self._solution["sid"],
            )
        return self._assets

    @property
    def builds(self):
        """
        Access the builds

        :returns: twilio.rest.serverless.v1.service.BuildList
        :rtype: twilio.rest.serverless.v1.service.BuildList
        """
        if self._builds is None:
            self._builds = BuildList(
                self._version,
                self._solution["sid"],
            )
        return self._builds

    @property
    def environments(self):
        """
        Access the environments

        :returns: twilio.rest.serverless.v1.service.EnvironmentList
        :rtype: twilio.rest.serverless.v1.service.EnvironmentList
        """
        if self._environments is None:
            self._environments = EnvironmentList(
                self._version,
                self._solution["sid"],
            )
        return self._environments

    @property
    def functions(self):
        """
        Access the functions

        :returns: twilio.rest.serverless.v1.service.FunctionList
        :rtype: twilio.rest.serverless.v1.service.FunctionList
        """
        if self._functions is None:
            self._functions = FunctionList(
                self._version,
                self._solution["sid"],
            )
        return self._functions

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        context = " ".join("{}={}".format(k, v) for k, v in self._solution.items())
        return "<Twilio.Serverless.V1.ServiceContext {}>".format(context)


class ServicePage(Page):
    def get_instance(self, payload):
        """
        Build an instance of ServiceInstance

        :param dict payload: Payload response from the API

        :returns: twilio.rest.serverless.v1.service.ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        return ServiceInstance(self._version, payload)

    def __repr__(self) -> str:
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        """
        return "<Twilio.Serverless.V1.ServicePage>"


class ServiceList(ListResource):
    def __init__(self, version: Version):
        """
        Initialize the ServiceList

        :param Version version: Version that contains the resource

        :returns: twilio.rest.serverless.v1.service.ServiceList
        :rtype: twilio.rest.serverless.v1.service.ServiceList
        """
        super().__init__(version)

        self._uri = "/Services"

    def create(
        self,
        unique_name,
        friendly_name,
        include_credentials=values.unset,
        ui_editable=values.unset,
    ):
        """
        Create the ServiceInstance

        :param str unique_name: A user-defined string that uniquely identifies the Service resource. It can be used as an alternative to the `sid` in the URL path to address the Service resource. This value must be 50 characters or less in length and be unique.
        :param str friendly_name: A descriptive string that you create to describe the Service resource. It can be a maximum of 255 characters.
        :param bool include_credentials: Whether to inject Account credentials into a function invocation context. The default value is `true`.
        :param bool ui_editable: Whether the Service's properties and subresources can be edited via the UI. The default value is `false`.

        :returns: The created ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        data = values.of(
            {
                "UniqueName": unique_name,
                "FriendlyName": friendly_name,
                "IncludeCredentials": include_credentials,
                "UiEditable": ui_editable,
            }
        )

        payload = self._version.create(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return ServiceInstance(self._version, payload)

    async def create_async(
        self,
        unique_name,
        friendly_name,
        include_credentials=values.unset,
        ui_editable=values.unset,
    ):
        """
        Asynchronously create the ServiceInstance

        :param str unique_name: A user-defined string that uniquely identifies the Service resource. It can be used as an alternative to the `sid` in the URL path to address the Service resource. This value must be 50 characters or less in length and be unique.
        :param str friendly_name: A descriptive string that you create to describe the Service resource. It can be a maximum of 255 characters.
        :param bool include_credentials: Whether to inject Account credentials into a function invocation context. The default value is `true`.
        :param bool ui_editable: Whether the Service's properties and subresources can be edited via the UI. The default value is `false`.

        :returns: The created ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServiceInstance
        """
        data = values.of(
            {
                "UniqueName": unique_name,
                "FriendlyName": friendly_name,
                "IncludeCredentials": include_credentials,
                "UiEditable": ui_editable,
            }
        )

        payload = await self._version.create_async(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return ServiceInstance(self._version, payload)

    def stream(self, limit=None, page_size=None):
        """
        Streams ServiceInstance records from the API as a generator stream.
        This operation lazily loads records as efficiently as possible until the limit
        is reached.
        The results are returned as a generator, so this operation is memory efficient.

        :param int limit: Upper limit for the number of records to return. stream()
                          guarantees to never return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, stream() will attempt to read the
                              limit with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.serverless.v1.service.ServiceInstance]
        """
        limits = self._version.read_limits(limit, page_size)
        page = self.page(page_size=limits["page_size"])

        return self._version.stream(page, limits["limit"])

    async def stream_async(self, limit=None, page_size=None):
        """
        Asynchronously streams ServiceInstance records from the API as a generator stream.
        This operation lazily loads records as efficiently as possible until the limit
        is reached.
        The results are returned as a generator, so this operation is memory efficient.

        :param int limit: Upper limit for the number of records to return. stream()
                          guarantees to never return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, stream() will attempt to read the
                              limit with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.serverless.v1.service.ServiceInstance]
        """
        limits = self._version.read_limits(limit, page_size)
        page = await self.page_async(page_size=limits["page_size"])

        return await self._version.stream_async(page, limits["limit"])

    def list(self, limit=None, page_size=None):
        """
        Lists ServiceInstance records from the API as a list.
        Unlike stream(), this operation is eager and will load `limit` records into
        memory before returning.

        :param int limit: Upper limit for the number of records to return. list() guarantees
                          never to return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, list() will attempt to read the limit
                              with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.serverless.v1.service.ServiceInstance]
        """
        return list(
            self.stream(
                limit=limit,
                page_size=page_size,
            )
        )

    async def list_async(self, limit=None, page_size=None):
        """
        Asynchronously lists ServiceInstance records from the API as a list.
        Unlike stream(), this operation is eager and will load `limit` records into
        memory before returning.

        :param int limit: Upper limit for the number of records to return. list() guarantees
                          never to return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, list() will attempt to read the limit
                              with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.serverless.v1.service.ServiceInstance]
        """
        return list(
            await self.stream_async(
                limit=limit,
                page_size=page_size,
            )
        )

    def page(
        self, page_token=values.unset, page_number=values.unset, page_size=values.unset
    ):
        """
        Retrieve a single page of ServiceInstance records from the API.
        Request is executed immediately

        :param str page_token: PageToken provided by the API
        :param int page_number: Page Number, this value is simply for client state
        :param int page_size: Number of records to return, defaults to 50

        :returns: Page of ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServicePage
        """
        data = values.of(
            {
                "PageToken": page_token,
                "Page": page_number,
                "PageSize": page_size,
            }
        )

        response = self._version.page(method="GET", uri=self._uri, params=data)
        return ServicePage(self._version, response)

    async def page_async(
        self, page_token=values.unset, page_number=values.unset, page_size=values.unset
    ):
        """
        Asynchronously retrieve a single page of ServiceInstance records from the API.
        Request is executed immediately

        :param str page_token: PageToken provided by the API
        :param int page_number: Page Number, this value is simply for client state
        :param int page_size: Number of records to return, defaults to 50

        :returns: Page of ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServicePage
        """
        data = values.of(
            {
                "PageToken": page_token,
                "Page": page_number,
                "PageSize": page_size,
            }
        )

        response = await self._version.page_async(
            method="GET", uri=self._uri, params=data
        )
        return ServicePage(self._version, response)

    def get_page(self, target_url):
        """
        Retrieve a specific page of ServiceInstance records from the API.
        Request is executed immediately

        :param str target_url: API-generated URL for the requested results page

        :returns: Page of ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServicePage
        """
        response = self._version.domain.twilio.request("GET", target_url)
        return ServicePage(self._version, response)

    async def get_page_async(self, target_url):
        """
        Asynchronously retrieve a specific page of ServiceInstance records from the API.
        Request is executed immediately

        :param str target_url: API-generated URL for the requested results page

        :returns: Page of ServiceInstance
        :rtype: twilio.rest.serverless.v1.service.ServicePage
        """
        response = await self._version.domain.twilio.request_async("GET", target_url)
        return ServicePage(self._version, response)

    def get(self, sid):
        """
        Constructs a ServiceContext

        :param sid: The `sid` or `unique_name` of the Service resource to update.

        :returns: twilio.rest.serverless.v1.service.ServiceContext
        :rtype: twilio.rest.serverless.v1.service.ServiceContext
        """
        return ServiceContext(self._version, sid=sid)

    def __call__(self, sid):
        """
        Constructs a ServiceContext

        :param sid: The `sid` or `unique_name` of the Service resource to update.

        :returns: twilio.rest.serverless.v1.service.ServiceContext
        :rtype: twilio.rest.serverless.v1.service.ServiceContext
        """
        return ServiceContext(self._version, sid=sid)

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        return "<Twilio.Serverless.V1.ServiceList>"
