r"""
    This code was generated by
   ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
    |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
    |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \

    Twilio - Video
    This is the public Twilio REST API.

    NOTE: This class is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
    Do not edit the class manually.
"""


from typing import Optional
from twilio.base import values
from twilio.base.instance_context import InstanceContext
from twilio.base.instance_resource import InstanceResource
from twilio.base.list_resource import ListResource
from twilio.base.version import Version


class RecordingSettingsInstance(InstanceResource):
    def __init__(self, version, payload):
        """
        Initialize the RecordingSettingsInstance

        :returns: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """
        super().__init__(version)

        self._properties = {
            "account_sid": payload.get("account_sid"),
            "friendly_name": payload.get("friendly_name"),
            "aws_credentials_sid": payload.get("aws_credentials_sid"),
            "aws_s3_url": payload.get("aws_s3_url"),
            "aws_storage_enabled": payload.get("aws_storage_enabled"),
            "encryption_key_sid": payload.get("encryption_key_sid"),
            "encryption_enabled": payload.get("encryption_enabled"),
            "url": payload.get("url"),
        }

        self._solution = {}
        self._context: Optional[RecordingSettingsContext] = None

    @property
    def _proxy(self):
        """
        Generate an instance context for the instance, the context is capable of
        performing various actions. All instance actions are proxied to the context

        :returns: RecordingSettingsContext for this RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsContext
        """
        if self._context is None:
            self._context = RecordingSettingsContext(
                self._version,
            )
        return self._context

    @property
    def account_sid(self):
        """
        :returns: The SID of the [Account](https://www.twilio.com/docs/iam/api/account) that created the RecordingSettings resource.
        :rtype: str
        """
        return self._properties["account_sid"]

    @property
    def friendly_name(self):
        """
        :returns: The string that you assigned to describe the resource and show the user in the console
        :rtype: str
        """
        return self._properties["friendly_name"]

    @property
    def aws_credentials_sid(self):
        """
        :returns: The SID of the stored Credential resource.
        :rtype: str
        """
        return self._properties["aws_credentials_sid"]

    @property
    def aws_s3_url(self):
        """
        :returns: The URL of the AWS S3 bucket where the recordings are stored. We only support DNS-compliant URLs like `https://documentation-example-twilio-bucket/recordings`, where `recordings` is the path in which you want the recordings to be stored. This URL accepts only URI-valid characters, as described in the <a href='https://tools.ietf.org/html/rfc3986#section-2'>RFC 3986</a>.
        :rtype: str
        """
        return self._properties["aws_s3_url"]

    @property
    def aws_storage_enabled(self):
        """
        :returns: Whether all recordings are written to the `aws_s3_url`. When `false`, all recordings are stored in our cloud.
        :rtype: bool
        """
        return self._properties["aws_storage_enabled"]

    @property
    def encryption_key_sid(self):
        """
        :returns: The SID of the Public Key resource used for encryption.
        :rtype: str
        """
        return self._properties["encryption_key_sid"]

    @property
    def encryption_enabled(self):
        """
        :returns: Whether all recordings are stored in an encrypted form. The default is `false`.
        :rtype: bool
        """
        return self._properties["encryption_enabled"]

    @property
    def url(self):
        """
        :returns: The absolute URL of the resource.
        :rtype: str
        """
        return self._properties["url"]

    def create(
        self,
        friendly_name,
        aws_credentials_sid=values.unset,
        encryption_key_sid=values.unset,
        aws_s3_url=values.unset,
        aws_storage_enabled=values.unset,
        encryption_enabled=values.unset,
    ):
        """
        Create the RecordingSettingsInstance

        :param str friendly_name: A descriptive string that you create to describe the resource and be shown to users in the console
        :param str aws_credentials_sid: The SID of the stored Credential resource.
        :param str encryption_key_sid: The SID of the Public Key resource to use for encryption.
        :param str aws_s3_url: The URL of the AWS S3 bucket where the recordings should be stored. We only support DNS-compliant URLs like `https://documentation-example-twilio-bucket/recordings`, where `recordings` is the path in which you want the recordings to be stored. This URL accepts only URI-valid characters, as described in the <a href='https://tools.ietf.org/html/rfc3986#section-2'>RFC 3986</a>.
        :param bool aws_storage_enabled: Whether all recordings should be written to the `aws_s3_url`. When `false`, all recordings are stored in our cloud.
        :param bool encryption_enabled: Whether all recordings should be stored in an encrypted form. The default is `false`.

        :returns: The created RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """
        return self._proxy.create(
            friendly_name,
            aws_credentials_sid=aws_credentials_sid,
            encryption_key_sid=encryption_key_sid,
            aws_s3_url=aws_s3_url,
            aws_storage_enabled=aws_storage_enabled,
            encryption_enabled=encryption_enabled,
        )

    async def create_async(
        self,
        friendly_name,
        aws_credentials_sid=values.unset,
        encryption_key_sid=values.unset,
        aws_s3_url=values.unset,
        aws_storage_enabled=values.unset,
        encryption_enabled=values.unset,
    ):
        """
        Asynchronous coroutine to create the RecordingSettingsInstance

        :param str friendly_name: A descriptive string that you create to describe the resource and be shown to users in the console
        :param str aws_credentials_sid: The SID of the stored Credential resource.
        :param str encryption_key_sid: The SID of the Public Key resource to use for encryption.
        :param str aws_s3_url: The URL of the AWS S3 bucket where the recordings should be stored. We only support DNS-compliant URLs like `https://documentation-example-twilio-bucket/recordings`, where `recordings` is the path in which you want the recordings to be stored. This URL accepts only URI-valid characters, as described in the <a href='https://tools.ietf.org/html/rfc3986#section-2'>RFC 3986</a>.
        :param bool aws_storage_enabled: Whether all recordings should be written to the `aws_s3_url`. When `false`, all recordings are stored in our cloud.
        :param bool encryption_enabled: Whether all recordings should be stored in an encrypted form. The default is `false`.

        :returns: The created RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """
        return await self._proxy.create_async(
            friendly_name,
            aws_credentials_sid=aws_credentials_sid,
            encryption_key_sid=encryption_key_sid,
            aws_s3_url=aws_s3_url,
            aws_storage_enabled=aws_storage_enabled,
            encryption_enabled=encryption_enabled,
        )

    def fetch(self):
        """
        Fetch the RecordingSettingsInstance


        :returns: The fetched RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """
        return self._proxy.fetch()

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the RecordingSettingsInstance


        :returns: The fetched RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """
        return await self._proxy.fetch_async()

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        context = " ".join("{}={}".format(k, v) for k, v in self._solution.items())
        return "<Twilio.Video.V1.RecordingSettingsInstance {}>".format(context)


class RecordingSettingsContext(InstanceContext):
    def __init__(self, version: Version):
        """
        Initialize the RecordingSettingsContext

        :param Version version: Version that contains the resource

        :returns: twilio.rest.video.v1.recording_settings.RecordingSettingsContext
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsContext
        """
        super().__init__(version)

        self._uri = "/RecordingSettings/Default"

    def create(
        self,
        friendly_name,
        aws_credentials_sid=values.unset,
        encryption_key_sid=values.unset,
        aws_s3_url=values.unset,
        aws_storage_enabled=values.unset,
        encryption_enabled=values.unset,
    ):
        """
        Create the RecordingSettingsInstance

        :param str friendly_name: A descriptive string that you create to describe the resource and be shown to users in the console
        :param str aws_credentials_sid: The SID of the stored Credential resource.
        :param str encryption_key_sid: The SID of the Public Key resource to use for encryption.
        :param str aws_s3_url: The URL of the AWS S3 bucket where the recordings should be stored. We only support DNS-compliant URLs like `https://documentation-example-twilio-bucket/recordings`, where `recordings` is the path in which you want the recordings to be stored. This URL accepts only URI-valid characters, as described in the <a href='https://tools.ietf.org/html/rfc3986#section-2'>RFC 3986</a>.
        :param bool aws_storage_enabled: Whether all recordings should be written to the `aws_s3_url`. When `false`, all recordings are stored in our cloud.
        :param bool encryption_enabled: Whether all recordings should be stored in an encrypted form. The default is `false`.

        :returns: The created RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """
        data = values.of(
            {
                "FriendlyName": friendly_name,
                "AwsCredentialsSid": aws_credentials_sid,
                "EncryptionKeySid": encryption_key_sid,
                "AwsS3Url": aws_s3_url,
                "AwsStorageEnabled": aws_storage_enabled,
                "EncryptionEnabled": encryption_enabled,
            }
        )

        payload = self._version.create(method="POST", uri=self._uri, data=data)

        return RecordingSettingsInstance(self._version, payload)

    async def create_async(
        self,
        friendly_name,
        aws_credentials_sid=values.unset,
        encryption_key_sid=values.unset,
        aws_s3_url=values.unset,
        aws_storage_enabled=values.unset,
        encryption_enabled=values.unset,
    ):
        """
        Asynchronous coroutine to create the RecordingSettingsInstance

        :param str friendly_name: A descriptive string that you create to describe the resource and be shown to users in the console
        :param str aws_credentials_sid: The SID of the stored Credential resource.
        :param str encryption_key_sid: The SID of the Public Key resource to use for encryption.
        :param str aws_s3_url: The URL of the AWS S3 bucket where the recordings should be stored. We only support DNS-compliant URLs like `https://documentation-example-twilio-bucket/recordings`, where `recordings` is the path in which you want the recordings to be stored. This URL accepts only URI-valid characters, as described in the <a href='https://tools.ietf.org/html/rfc3986#section-2'>RFC 3986</a>.
        :param bool aws_storage_enabled: Whether all recordings should be written to the `aws_s3_url`. When `false`, all recordings are stored in our cloud.
        :param bool encryption_enabled: Whether all recordings should be stored in an encrypted form. The default is `false`.

        :returns: The created RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """
        data = values.of(
            {
                "FriendlyName": friendly_name,
                "AwsCredentialsSid": aws_credentials_sid,
                "EncryptionKeySid": encryption_key_sid,
                "AwsS3Url": aws_s3_url,
                "AwsStorageEnabled": aws_storage_enabled,
                "EncryptionEnabled": encryption_enabled,
            }
        )

        payload = await self._version.create_async(
            method="POST", uri=self._uri, data=data
        )

        return RecordingSettingsInstance(self._version, payload)

    def fetch(self):
        """
        Fetch the RecordingSettingsInstance


        :returns: The fetched RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """

        payload = self._version.fetch(
            method="GET",
            uri=self._uri,
        )

        return RecordingSettingsInstance(
            self._version,
            payload,
        )

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the RecordingSettingsInstance


        :returns: The fetched RecordingSettingsInstance
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsInstance
        """

        payload = await self._version.fetch_async(
            method="GET",
            uri=self._uri,
        )

        return RecordingSettingsInstance(
            self._version,
            payload,
        )

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """

        return "<Twilio.Video.V1.RecordingSettingsContext>"


class RecordingSettingsList(ListResource):
    def __init__(self, version: Version):
        """
        Initialize the RecordingSettingsList

        :param Version version: Version that contains the resource

        :returns: twilio.rest.video.v1.recording_settings.RecordingSettingsList
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsList
        """
        super().__init__(version)

    def get(self):
        """
        Constructs a RecordingSettingsContext


        :returns: twilio.rest.video.v1.recording_settings.RecordingSettingsContext
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsContext
        """
        return RecordingSettingsContext(self._version)

    def __call__(self):
        """
        Constructs a RecordingSettingsContext


        :returns: twilio.rest.video.v1.recording_settings.RecordingSettingsContext
        :rtype: twilio.rest.video.v1.recording_settings.RecordingSettingsContext
        """
        return RecordingSettingsContext(self._version)

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        return "<Twilio.Video.V1.RecordingSettingsList>"
