r"""
    This code was generated by
   ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
    |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
    |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \

    Twilio - Voice
    This is the public Twilio REST API.

    NOTE: This class is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
    Do not edit the class manually.
"""


from typing import Optional
from twilio.base import deserialize, values
from twilio.base.instance_context import InstanceContext
from twilio.base.instance_resource import InstanceResource
from twilio.base.list_resource import ListResource
from twilio.base.version import Version
from twilio.base.page import Page


class SourceIpMappingInstance(InstanceResource):
    def __init__(self, version, payload, sid: Optional[str] = None):
        """
        Initialize the SourceIpMappingInstance

        :returns: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        super().__init__(version)

        self._properties = {
            "sid": payload.get("sid"),
            "ip_record_sid": payload.get("ip_record_sid"),
            "sip_domain_sid": payload.get("sip_domain_sid"),
            "date_created": deserialize.iso8601_datetime(payload.get("date_created")),
            "date_updated": deserialize.iso8601_datetime(payload.get("date_updated")),
            "url": payload.get("url"),
        }

        self._solution = {
            "sid": sid or self._properties["sid"],
        }
        self._context: Optional[SourceIpMappingContext] = None

    @property
    def _proxy(self):
        """
        Generate an instance context for the instance, the context is capable of
        performing various actions. All instance actions are proxied to the context

        :returns: SourceIpMappingContext for this SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingContext
        """
        if self._context is None:
            self._context = SourceIpMappingContext(
                self._version,
                sid=self._solution["sid"],
            )
        return self._context

    @property
    def sid(self):
        """
        :returns: The unique string that we created to identify the IP Record resource.
        :rtype: str
        """
        return self._properties["sid"]

    @property
    def ip_record_sid(self):
        """
        :returns: The Twilio-provided string that uniquely identifies the IP Record resource to map from.
        :rtype: str
        """
        return self._properties["ip_record_sid"]

    @property
    def sip_domain_sid(self):
        """
        :returns: The SID of the SIP Domain that the IP Record is mapped to.
        :rtype: str
        """
        return self._properties["sip_domain_sid"]

    @property
    def date_created(self):
        """
        :returns: The date and time in GMT that the resource was created specified in [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt) format.
        :rtype: datetime
        """
        return self._properties["date_created"]

    @property
    def date_updated(self):
        """
        :returns: The date and time in GMT that the resource was last updated specified in [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt) format.
        :rtype: datetime
        """
        return self._properties["date_updated"]

    @property
    def url(self):
        """
        :returns: The absolute URL of the resource.
        :rtype: str
        """
        return self._properties["url"]

    def delete(self):
        """
        Deletes the SourceIpMappingInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return self._proxy.delete()

    async def delete_async(self):
        """
        Asynchronous coroutine that deletes the SourceIpMappingInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return await self._proxy.delete_async()

    def fetch(self):
        """
        Fetch the SourceIpMappingInstance


        :returns: The fetched SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        return self._proxy.fetch()

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the SourceIpMappingInstance


        :returns: The fetched SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        return await self._proxy.fetch_async()

    def update(self, sip_domain_sid):
        """
        Update the SourceIpMappingInstance

        :param str sip_domain_sid: The SID of the SIP Domain that the IP Record should be mapped to.

        :returns: The updated SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        return self._proxy.update(
            sip_domain_sid=sip_domain_sid,
        )

    async def update_async(self, sip_domain_sid):
        """
        Asynchronous coroutine to update the SourceIpMappingInstance

        :param str sip_domain_sid: The SID of the SIP Domain that the IP Record should be mapped to.

        :returns: The updated SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        return await self._proxy.update_async(
            sip_domain_sid=sip_domain_sid,
        )

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        context = " ".join("{}={}".format(k, v) for k, v in self._solution.items())
        return "<Twilio.Voice.V1.SourceIpMappingInstance {}>".format(context)


class SourceIpMappingContext(InstanceContext):
    def __init__(self, version: Version, sid: str):
        """
        Initialize the SourceIpMappingContext

        :param Version version: Version that contains the resource
        :param sid: The Twilio-provided string that uniquely identifies the IP Record resource to update.

        :returns: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingContext
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingContext
        """
        super().__init__(version)

        # Path Solution
        self._solution = {
            "sid": sid,
        }
        self._uri = "/SourceIpMappings/{sid}".format(**self._solution)

    def delete(self):
        """
        Deletes the SourceIpMappingInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return self._version.delete(
            method="DELETE",
            uri=self._uri,
        )

    async def delete_async(self):
        """
        Asynchronous coroutine that deletes the SourceIpMappingInstance


        :returns: True if delete succeeds, False otherwise
        :rtype: bool
        """
        return await self._version.delete_async(
            method="DELETE",
            uri=self._uri,
        )

    def fetch(self):
        """
        Fetch the SourceIpMappingInstance


        :returns: The fetched SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """

        payload = self._version.fetch(
            method="GET",
            uri=self._uri,
        )

        return SourceIpMappingInstance(
            self._version,
            payload,
            sid=self._solution["sid"],
        )

    async def fetch_async(self):
        """
        Asynchronous coroutine to fetch the SourceIpMappingInstance


        :returns: The fetched SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """

        payload = await self._version.fetch_async(
            method="GET",
            uri=self._uri,
        )

        return SourceIpMappingInstance(
            self._version,
            payload,
            sid=self._solution["sid"],
        )

    def update(self, sip_domain_sid):
        """
        Update the SourceIpMappingInstance

        :param str sip_domain_sid: The SID of the SIP Domain that the IP Record should be mapped to.

        :returns: The updated SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        data = values.of(
            {
                "SipDomainSid": sip_domain_sid,
            }
        )

        payload = self._version.update(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return SourceIpMappingInstance(
            self._version, payload, sid=self._solution["sid"]
        )

    async def update_async(self, sip_domain_sid):
        """
        Asynchronous coroutine to update the SourceIpMappingInstance

        :param str sip_domain_sid: The SID of the SIP Domain that the IP Record should be mapped to.

        :returns: The updated SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        data = values.of(
            {
                "SipDomainSid": sip_domain_sid,
            }
        )

        payload = await self._version.update_async(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return SourceIpMappingInstance(
            self._version, payload, sid=self._solution["sid"]
        )

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        context = " ".join("{}={}".format(k, v) for k, v in self._solution.items())
        return "<Twilio.Voice.V1.SourceIpMappingContext {}>".format(context)


class SourceIpMappingPage(Page):
    def get_instance(self, payload):
        """
        Build an instance of SourceIpMappingInstance

        :param dict payload: Payload response from the API

        :returns: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        return SourceIpMappingInstance(self._version, payload)

    def __repr__(self) -> str:
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        """
        return "<Twilio.Voice.V1.SourceIpMappingPage>"


class SourceIpMappingList(ListResource):
    def __init__(self, version: Version):
        """
        Initialize the SourceIpMappingList

        :param Version version: Version that contains the resource

        :returns: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingList
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingList
        """
        super().__init__(version)

        self._uri = "/SourceIpMappings"

    def create(self, ip_record_sid, sip_domain_sid):
        """
        Create the SourceIpMappingInstance

        :param str ip_record_sid: The Twilio-provided string that uniquely identifies the IP Record resource to map from.
        :param str sip_domain_sid: The SID of the SIP Domain that the IP Record should be mapped to.

        :returns: The created SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        data = values.of(
            {
                "IpRecordSid": ip_record_sid,
                "SipDomainSid": sip_domain_sid,
            }
        )

        payload = self._version.create(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return SourceIpMappingInstance(self._version, payload)

    async def create_async(self, ip_record_sid, sip_domain_sid):
        """
        Asynchronously create the SourceIpMappingInstance

        :param str ip_record_sid: The Twilio-provided string that uniquely identifies the IP Record resource to map from.
        :param str sip_domain_sid: The SID of the SIP Domain that the IP Record should be mapped to.

        :returns: The created SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance
        """
        data = values.of(
            {
                "IpRecordSid": ip_record_sid,
                "SipDomainSid": sip_domain_sid,
            }
        )

        payload = await self._version.create_async(
            method="POST",
            uri=self._uri,
            data=data,
        )

        return SourceIpMappingInstance(self._version, payload)

    def stream(self, limit=None, page_size=None):
        """
        Streams SourceIpMappingInstance records from the API as a generator stream.
        This operation lazily loads records as efficiently as possible until the limit
        is reached.
        The results are returned as a generator, so this operation is memory efficient.

        :param int limit: Upper limit for the number of records to return. stream()
                          guarantees to never return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, stream() will attempt to read the
                              limit with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance]
        """
        limits = self._version.read_limits(limit, page_size)
        page = self.page(page_size=limits["page_size"])

        return self._version.stream(page, limits["limit"])

    async def stream_async(self, limit=None, page_size=None):
        """
        Asynchronously streams SourceIpMappingInstance records from the API as a generator stream.
        This operation lazily loads records as efficiently as possible until the limit
        is reached.
        The results are returned as a generator, so this operation is memory efficient.

        :param int limit: Upper limit for the number of records to return. stream()
                          guarantees to never return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, stream() will attempt to read the
                              limit with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance]
        """
        limits = self._version.read_limits(limit, page_size)
        page = await self.page_async(page_size=limits["page_size"])

        return await self._version.stream_async(page, limits["limit"])

    def list(self, limit=None, page_size=None):
        """
        Lists SourceIpMappingInstance records from the API as a list.
        Unlike stream(), this operation is eager and will load `limit` records into
        memory before returning.

        :param int limit: Upper limit for the number of records to return. list() guarantees
                          never to return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, list() will attempt to read the limit
                              with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance]
        """
        return list(
            self.stream(
                limit=limit,
                page_size=page_size,
            )
        )

    async def list_async(self, limit=None, page_size=None):
        """
        Asynchronously lists SourceIpMappingInstance records from the API as a list.
        Unlike stream(), this operation is eager and will load `limit` records into
        memory before returning.

        :param int limit: Upper limit for the number of records to return. list() guarantees
                          never to return more than limit.  Default is no limit
        :param int page_size: Number of records to fetch per request, when not set will use
                              the default value of 50 records.  If no page_size is defined
                              but a limit is defined, list() will attempt to read the limit
                              with the most efficient page size, i.e. min(limit, 1000)

        :returns: Generator that will yield up to limit results
        :rtype: list[twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingInstance]
        """
        return list(
            await self.stream_async(
                limit=limit,
                page_size=page_size,
            )
        )

    def page(
        self, page_token=values.unset, page_number=values.unset, page_size=values.unset
    ):
        """
        Retrieve a single page of SourceIpMappingInstance records from the API.
        Request is executed immediately

        :param str page_token: PageToken provided by the API
        :param int page_number: Page Number, this value is simply for client state
        :param int page_size: Number of records to return, defaults to 50

        :returns: Page of SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingPage
        """
        data = values.of(
            {
                "PageToken": page_token,
                "Page": page_number,
                "PageSize": page_size,
            }
        )

        response = self._version.page(method="GET", uri=self._uri, params=data)
        return SourceIpMappingPage(self._version, response)

    async def page_async(
        self, page_token=values.unset, page_number=values.unset, page_size=values.unset
    ):
        """
        Asynchronously retrieve a single page of SourceIpMappingInstance records from the API.
        Request is executed immediately

        :param str page_token: PageToken provided by the API
        :param int page_number: Page Number, this value is simply for client state
        :param int page_size: Number of records to return, defaults to 50

        :returns: Page of SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingPage
        """
        data = values.of(
            {
                "PageToken": page_token,
                "Page": page_number,
                "PageSize": page_size,
            }
        )

        response = await self._version.page_async(
            method="GET", uri=self._uri, params=data
        )
        return SourceIpMappingPage(self._version, response)

    def get_page(self, target_url):
        """
        Retrieve a specific page of SourceIpMappingInstance records from the API.
        Request is executed immediately

        :param str target_url: API-generated URL for the requested results page

        :returns: Page of SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingPage
        """
        response = self._version.domain.twilio.request("GET", target_url)
        return SourceIpMappingPage(self._version, response)

    async def get_page_async(self, target_url):
        """
        Asynchronously retrieve a specific page of SourceIpMappingInstance records from the API.
        Request is executed immediately

        :param str target_url: API-generated URL for the requested results page

        :returns: Page of SourceIpMappingInstance
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingPage
        """
        response = await self._version.domain.twilio.request_async("GET", target_url)
        return SourceIpMappingPage(self._version, response)

    def get(self, sid):
        """
        Constructs a SourceIpMappingContext

        :param sid: The Twilio-provided string that uniquely identifies the IP Record resource to update.

        :returns: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingContext
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingContext
        """
        return SourceIpMappingContext(self._version, sid=sid)

    def __call__(self, sid):
        """
        Constructs a SourceIpMappingContext

        :param sid: The Twilio-provided string that uniquely identifies the IP Record resource to update.

        :returns: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingContext
        :rtype: twilio.rest.voice.v1.source_ip_mapping.SourceIpMappingContext
        """
        return SourceIpMappingContext(self._version, sid=sid)

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        return "<Twilio.Voice.V1.SourceIpMappingList>"
